diff --git a/sysdeps/sparc/sparc32/fpu/s_fabs.S b/sysdeps/sparc/sparc32/fpu/s_fabs.S
deleted file mode 100644
index a03c9822d9..0000000000
--- a/sysdeps/sparc/sparc32/fpu/s_fabs.S
+++ /dev/null
@@ -1,30 +0,0 @@
-/* Float absolute value, sparc32 version.
-   Copyright (C) 2011-2022 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <sysdep.h>
-#include <math_ldbl_opt.h>
-#include <libm-alias-double.h>
-
-ENTRY (__fabs)
-	st	%o0, [%sp+72]
-	st	%o1, [%sp+76]
-	ldd	[%sp+72], %f0
-	retl
-	 fabss	%f0, %f0
-END (__fabs)
-libm_alias_double (__fabs, fabs)
diff --git a/sysdeps/sparc/sparc32/fpu/s_fabsf.S b/sysdeps/sparc/sparc32/fpu/s_fabsf.S
deleted file mode 100644
index 45bc46112c..0000000000
--- a/sysdeps/sparc/sparc32/fpu/s_fabsf.S
+++ /dev/null
@@ -1,28 +0,0 @@
-/* Float absolute value, sparc32 version.
-   Copyright (C) 2006-2022 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <sysdep.h>
-#include <libm-alias-float.h>
-
-ENTRY (__fabsf)
-	st	%o0, [%sp+68]
-	ld	[%sp+68], %f0
-	retl
-	 fabss	%f0, %f0
-END (__fabsf)
-libm_alias_float (__fabs, fabs)
diff --git a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabs-generic.S b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabs-generic.c
similarity index 71%
rename from sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabs-generic.S
rename to sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabs-generic.c
index 267dbd2352..b928e3db33 100644
--- a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabs-generic.S
+++ b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabs-generic.c
@@ -2,4 +2,4 @@
 #define __fabs __fabs_generic
 #undef libm_alias_double
 #define libm_alias_double(a, b)
-#include <sysdeps/sparc/sparc32/fpu/s_fabs.S>
+#include <sysdeps/ieee754/dbl-64/s_fabs.c>
diff --git a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabsf-generic.S b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabsf-generic.c
similarity index 71%
rename from sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabsf-generic.S
rename to sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabsf-generic.c
index b6fb38f34c..14883adcef 100644
--- a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabsf-generic.S
+++ b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fabsf-generic.c
@@ -2,4 +2,4 @@
 #define __fabsf __fabsf_generic
 #undef libm_alias_float
 #define libm_alias_float(a, b)
-#include <sysdeps/sparc/sparc32/fpu/s_fabsf.S>
+#include <sysdeps/ieee754/flt-32/s_fabsf.c>
diff --git a/sysdeps/sparc/sparc64/fpu/s_fabs.c b/sysdeps/sparc/sparc64/fpu/s_fabs.c
deleted file mode 100644
index 7862290da3..0000000000
--- a/sysdeps/sparc/sparc64/fpu/s_fabs.c
+++ /dev/null
@@ -1,7 +0,0 @@
-#include <libm-alias-double.h>
-
-double __fabs (double x)
-{
-  return __builtin_fabs (x);
-}
-libm_alias_double (__fabs, fabs)
diff --git a/sysdeps/sparc/sparc64/fpu/s_fabsf.c b/sysdeps/sparc/sparc64/fpu/s_fabsf.c
deleted file mode 100644
index 5f54f80bf5..0000000000
--- a/sysdeps/sparc/sparc64/fpu/s_fabsf.c
+++ /dev/null
@@ -1,7 +0,0 @@
-#include <libm-alias-float.h>
-
-float __fabsf (float x)
-{
-  return __builtin_fabsf (x);
-}
-libm_alias_float (__fabs, fabs)