diff --git a/sysdeps/aarch64/fast-jitter.h b/sysdeps/aarch64/fast-jitter.h
new file mode 100644
index 0000000000..fb09d2632c
--- /dev/null
+++ b/sysdeps/aarch64/fast-jitter.h
@@ -0,0 +1,33 @@
+/* Fast jitter on arm with HP_TIMING_NOW
+   Copyright (C) 2022-2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#ifndef _FAST_JITTER_H
+# define _FAST_JITTER_H
+
+#include <stdint.h>
+#include <hp-timing.h>
+
+static inline uint32_t
+get_fast_jitter (void)
+{
+  hp_timing_t jitter;
+  HP_TIMING_NOW (jitter);
+  return (uint32_t) jitter;
+}
+
+#endif
diff --git a/sysdeps/alpha/fast-jitter.h b/sysdeps/alpha/fast-jitter.h
new file mode 100644
index 0000000000..0a24290eaa
--- /dev/null
+++ b/sysdeps/alpha/fast-jitter.h
@@ -0,0 +1,34 @@
+/* Fast jitter on alpha with rpcc
+   Copyright (C) 2022-2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#ifndef _FAST_JITTER_H
+# define _FAST_JITTER_H
+
+#include <stdint.h>
+
+static inline uint32_t
+get_fast_jitter (void)
+{
+  unsigned long int x_;
+  asm volatile ("rpcc %0" : "=r"(x_));
+  /* Don't both with process offset.  We only need jitter not
+     monotonic cycle count.  */
+  return (uint32_t) x;
+}
+
+#endif
diff --git a/sysdeps/generic/fast-jitter.h b/sysdeps/generic/fast-jitter.h
new file mode 100644
index 0000000000..63bcf3ccd7
--- /dev/null
+++ b/sysdeps/generic/fast-jitter.h
@@ -0,0 +1,35 @@
+/* Fallback for fast jitter just return 0.
+   Copyright (C) 2019-2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#ifndef _FAST_JITTER_H
+# define _FAST_JITTER_H
+
+#include <stdint.h>
+
+/* Baseline just return 0.  We could create jitter using a clock or
+   'random_bits' but that may imply a syscall and the goal of
+   'get_fast_jitter' is minimal overhead "randomness" when such
+   randomness helps performance.  Adding high overhead the function
+   defeats the purpose.  */
+static inline uint32_t
+get_fast_jitter (void)
+{
+  return 0;
+}
+
+#endif
diff --git a/sysdeps/s390/fast-jitter.h b/sysdeps/s390/fast-jitter.h
new file mode 100644
index 0000000000..eb905b1413
--- /dev/null
+++ b/sysdeps/s390/fast-jitter.h
@@ -0,0 +1,33 @@
+/* Fast jitter on s390 with HP_TIMING_NOW
+   Copyright (C) 2022-2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#ifndef _FAST_JITTER_H
+# define _FAST_JITTER_H
+
+#include <stdint.h>
+#include <hp-timing.h>
+
+static inline uint32_t
+get_fast_jitter (void)
+{
+  hp_timing_t jitter;
+  HP_TIMING_NOW (jitter);
+  return (uint32_t) jitter;
+}
+
+#endif
diff --git a/sysdeps/sparc/fast-jitter.h b/sysdeps/sparc/fast-jitter.h
new file mode 100644
index 0000000000..f4413754c5
--- /dev/null
+++ b/sysdeps/sparc/fast-jitter.h
@@ -0,0 +1,33 @@
+/* Fast jitter on sparc with HP_TIMING_NOW
+   Copyright (C) 2022-2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#ifndef _FAST_JITTER_H
+# define _FAST_JITTER_H
+
+#include <stdint.h>
+#include <hp-timing.h>
+
+static inline uint32_t
+get_fast_jitter (void)
+{
+  hp_timing_t jitter;
+  HP_TIMING_NOW (jitter);
+  return (uint32_t) jitter;
+}
+
+#endif
diff --git a/sysdeps/x86_64/fast-jitter.h b/sysdeps/x86_64/fast-jitter.h
new file mode 100644
index 0000000000..1140f1c295
--- /dev/null
+++ b/sysdeps/x86_64/fast-jitter.h
@@ -0,0 +1,30 @@
+/* X86 use rdtsc to quickly generate pseudo-random for jitter
+   Copyright (C) 2022-2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#ifndef _FAST_JITTER_H
+# define _FAST_JITTER_H
+
+#include <stdint.h>
+
+static inline uint32_t
+get_fast_jitter (void)
+{
+  return __builtin_ia32_rdtsc ();
+}
+
+#endif